package com.hai.dao;

import com.hai.entity.ApiStarbucksProducts;
import com.hai.entity.ApiStarbucksProductsExample.Criteria;
import com.hai.entity.ApiStarbucksProductsExample.Criterion;
import com.hai.entity.ApiStarbucksProductsExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class ApiStarbucksProductsSqlProvider {

    public String countByExample(ApiStarbucksProductsExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("api_starbucks_products");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(ApiStarbucksProductsExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("api_starbucks_products");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(ApiStarbucksProducts record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("api_starbucks_products");
        
        if (record.getGoodsId() != null) {
            sql.VALUES("goods_id", "#{goodsId,jdbcType=BIGINT}");
        }
        
        if (record.getName() != null) {
            sql.VALUES("`name`", "#{name,jdbcType=VARCHAR}");
        }
        
        if (record.getDes() != null) {
            sql.VALUES("des", "#{des,jdbcType=VARCHAR}");
        }
        
        if (record.getDefaultImage() != null) {
            sql.VALUES("default_image", "#{defaultImage,jdbcType=VARCHAR}");
        }
        
        if (record.getCupSize() != null) {
            sql.VALUES("cup_size", "#{cupSize,jdbcType=VARCHAR}");
        }
        
        if (record.getTemperature() != null) {
            sql.VALUES("temperature", "#{temperature,jdbcType=VARCHAR}");
        }
        
        if (record.getCream() != null) {
            sql.VALUES("cream", "#{cream,jdbcType=VARCHAR}");
        }
        
        if (record.getEspresso() != null) {
            sql.VALUES("espresso", "#{espresso,jdbcType=VARCHAR}");
        }
        
        if (record.getMilk() != null) {
            sql.VALUES("milk", "#{milk,jdbcType=VARCHAR}");
        }
        
        if (record.getMilkBubble() != null) {
            sql.VALUES("milk_bubble", "#{milkBubble,jdbcType=VARCHAR}");
        }
        
        if (record.getCategoryName() != null) {
            sql.VALUES("category_name", "#{categoryName,jdbcType=VARCHAR}");
        }
        
        if (record.getMarketTallPrice() != null) {
            sql.VALUES("market_tall_price", "#{marketTallPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getMarketGrandePrice() != null) {
            sql.VALUES("market_grande_price", "#{marketGrandePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getMarketVentiPrice() != null) {
            sql.VALUES("market_venti_price", "#{marketVentiPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSalesTallPrice() != null) {
            sql.VALUES("sales_tall_price", "#{salesTallPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSalesGrandePrice() != null) {
            sql.VALUES("sales_grande_price", "#{salesGrandePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSalesVentiPrice() != null) {
            sql.VALUES("sales_venti_price", "#{salesVentiPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getOperatorId() != null) {
            sql.VALUES("operator_id", "#{operatorId,jdbcType=BIGINT}");
        }
        
        if (record.getOperatorName() != null) {
            sql.VALUES("operator_name", "#{operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(ApiStarbucksProductsExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("goods_id");
        sql.SELECT("`name`");
        sql.SELECT("des");
        sql.SELECT("default_image");
        sql.SELECT("cup_size");
        sql.SELECT("temperature");
        sql.SELECT("cream");
        sql.SELECT("espresso");
        sql.SELECT("milk");
        sql.SELECT("milk_bubble");
        sql.SELECT("category_name");
        sql.SELECT("market_tall_price");
        sql.SELECT("market_grande_price");
        sql.SELECT("market_venti_price");
        sql.SELECT("sales_tall_price");
        sql.SELECT("sales_grande_price");
        sql.SELECT("sales_venti_price");
        sql.SELECT("operator_id");
        sql.SELECT("operator_name");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("`status`");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("api_starbucks_products");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        ApiStarbucksProducts record = (ApiStarbucksProducts) parameter.get("record");
        ApiStarbucksProductsExample example = (ApiStarbucksProductsExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("api_starbucks_products");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getGoodsId() != null) {
            sql.SET("goods_id = #{record.goodsId,jdbcType=BIGINT}");
        }
        
        if (record.getName() != null) {
            sql.SET("`name` = #{record.name,jdbcType=VARCHAR}");
        }
        
        if (record.getDes() != null) {
            sql.SET("des = #{record.des,jdbcType=VARCHAR}");
        }
        
        if (record.getDefaultImage() != null) {
            sql.SET("default_image = #{record.defaultImage,jdbcType=VARCHAR}");
        }
        
        if (record.getCupSize() != null) {
            sql.SET("cup_size = #{record.cupSize,jdbcType=VARCHAR}");
        }
        
        if (record.getTemperature() != null) {
            sql.SET("temperature = #{record.temperature,jdbcType=VARCHAR}");
        }
        
        if (record.getCream() != null) {
            sql.SET("cream = #{record.cream,jdbcType=VARCHAR}");
        }
        
        if (record.getEspresso() != null) {
            sql.SET("espresso = #{record.espresso,jdbcType=VARCHAR}");
        }
        
        if (record.getMilk() != null) {
            sql.SET("milk = #{record.milk,jdbcType=VARCHAR}");
        }
        
        if (record.getMilkBubble() != null) {
            sql.SET("milk_bubble = #{record.milkBubble,jdbcType=VARCHAR}");
        }
        
        if (record.getCategoryName() != null) {
            sql.SET("category_name = #{record.categoryName,jdbcType=VARCHAR}");
        }
        
        if (record.getMarketTallPrice() != null) {
            sql.SET("market_tall_price = #{record.marketTallPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getMarketGrandePrice() != null) {
            sql.SET("market_grande_price = #{record.marketGrandePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getMarketVentiPrice() != null) {
            sql.SET("market_venti_price = #{record.marketVentiPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSalesTallPrice() != null) {
            sql.SET("sales_tall_price = #{record.salesTallPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSalesGrandePrice() != null) {
            sql.SET("sales_grande_price = #{record.salesGrandePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSalesVentiPrice() != null) {
            sql.SET("sales_venti_price = #{record.salesVentiPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getOperatorId() != null) {
            sql.SET("operator_id = #{record.operatorId,jdbcType=BIGINT}");
        }
        
        if (record.getOperatorName() != null) {
            sql.SET("operator_name = #{record.operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("api_starbucks_products");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("goods_id = #{record.goodsId,jdbcType=BIGINT}");
        sql.SET("`name` = #{record.name,jdbcType=VARCHAR}");
        sql.SET("des = #{record.des,jdbcType=VARCHAR}");
        sql.SET("default_image = #{record.defaultImage,jdbcType=VARCHAR}");
        sql.SET("cup_size = #{record.cupSize,jdbcType=VARCHAR}");
        sql.SET("temperature = #{record.temperature,jdbcType=VARCHAR}");
        sql.SET("cream = #{record.cream,jdbcType=VARCHAR}");
        sql.SET("espresso = #{record.espresso,jdbcType=VARCHAR}");
        sql.SET("milk = #{record.milk,jdbcType=VARCHAR}");
        sql.SET("milk_bubble = #{record.milkBubble,jdbcType=VARCHAR}");
        sql.SET("category_name = #{record.categoryName,jdbcType=VARCHAR}");
        sql.SET("market_tall_price = #{record.marketTallPrice,jdbcType=DECIMAL}");
        sql.SET("market_grande_price = #{record.marketGrandePrice,jdbcType=DECIMAL}");
        sql.SET("market_venti_price = #{record.marketVentiPrice,jdbcType=DECIMAL}");
        sql.SET("sales_tall_price = #{record.salesTallPrice,jdbcType=DECIMAL}");
        sql.SET("sales_grande_price = #{record.salesGrandePrice,jdbcType=DECIMAL}");
        sql.SET("sales_venti_price = #{record.salesVentiPrice,jdbcType=DECIMAL}");
        sql.SET("operator_id = #{record.operatorId,jdbcType=BIGINT}");
        sql.SET("operator_name = #{record.operatorName,jdbcType=VARCHAR}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        ApiStarbucksProductsExample example = (ApiStarbucksProductsExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(ApiStarbucksProducts record) {
        SQL sql = new SQL();
        sql.UPDATE("api_starbucks_products");
        
        if (record.getGoodsId() != null) {
            sql.SET("goods_id = #{goodsId,jdbcType=BIGINT}");
        }
        
        if (record.getName() != null) {
            sql.SET("`name` = #{name,jdbcType=VARCHAR}");
        }
        
        if (record.getDes() != null) {
            sql.SET("des = #{des,jdbcType=VARCHAR}");
        }
        
        if (record.getDefaultImage() != null) {
            sql.SET("default_image = #{defaultImage,jdbcType=VARCHAR}");
        }
        
        if (record.getCupSize() != null) {
            sql.SET("cup_size = #{cupSize,jdbcType=VARCHAR}");
        }
        
        if (record.getTemperature() != null) {
            sql.SET("temperature = #{temperature,jdbcType=VARCHAR}");
        }
        
        if (record.getCream() != null) {
            sql.SET("cream = #{cream,jdbcType=VARCHAR}");
        }
        
        if (record.getEspresso() != null) {
            sql.SET("espresso = #{espresso,jdbcType=VARCHAR}");
        }
        
        if (record.getMilk() != null) {
            sql.SET("milk = #{milk,jdbcType=VARCHAR}");
        }
        
        if (record.getMilkBubble() != null) {
            sql.SET("milk_bubble = #{milkBubble,jdbcType=VARCHAR}");
        }
        
        if (record.getCategoryName() != null) {
            sql.SET("category_name = #{categoryName,jdbcType=VARCHAR}");
        }
        
        if (record.getMarketTallPrice() != null) {
            sql.SET("market_tall_price = #{marketTallPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getMarketGrandePrice() != null) {
            sql.SET("market_grande_price = #{marketGrandePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getMarketVentiPrice() != null) {
            sql.SET("market_venti_price = #{marketVentiPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSalesTallPrice() != null) {
            sql.SET("sales_tall_price = #{salesTallPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSalesGrandePrice() != null) {
            sql.SET("sales_grande_price = #{salesGrandePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSalesVentiPrice() != null) {
            sql.SET("sales_venti_price = #{salesVentiPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getOperatorId() != null) {
            sql.SET("operator_id = #{operatorId,jdbcType=BIGINT}");
        }
        
        if (record.getOperatorName() != null) {
            sql.SET("operator_name = #{operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, ApiStarbucksProductsExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}